import { jsxs as t, jsx as e } from "react/jsx-runtime";

import { useState as o, useLayoutEffect as r, useMemo as n, useCallback as i, useEffect as s, useRef as l } from "react";

import { VirtualScrollerEvent as c, VirtualScroller as a } from "@af-utils/virtual-core";

import { useSyncExternalStore as h } from "use-sync-external-store/shim/index.js";

const d = (t, e) => {
    const o = [];
    for (let r = t.from, n = t.to; n > r; r++) o.push(e(r));
    return o;
}, f = (t, e) => {
    const o = [];
    for (let r = t.from, n = t.to, i = t.getOffset(r); n > r; i += t.getSize(r), r++) o.push(e(r, i));
    return o;
}, u = {
    position: "relative",
    overflow: "hidden",
    contain: "strict",
    zIndex: -1
}, m = {
    ...u,
    height: "100%"
}, p = {
    ...u,
    width: "100%"
}, y = {
    position: "absolute",
    contain: "strict",
    overflow: "hidden",
    top: 0,
    left: 0
}, S = {
    ...y,
    display: "flex",
    height: "100%"
}, g = {
    ...y,
    display: "block",
    width: "100%"
}, w = t => {
    const [e, n] = o(null), [i, s] = o(null);
    return r((() => {
        if (t && e && i) {
            const o = () => {
                e.style[t.horizontal ? "width" : "height"] = t.scrollSize + "px";
            }, r = () => {
                const e = t.getOffset(t.from), o = t.getOffset(t.to);
                i.style.transform = `translate${t.horizontal ? "X" : "Y"}(${e}px)`, i.style[t.horizontal ? "width" : "height"] = o - e + "px";
            }, n = t.on(o, [ c.SCROLL_SIZE ]), s = t.on(r, [ c.RANGE, c.SIZES ]);
            return Object.assign(e.style, t.horizontal ? m : p), Object.assign(i.style, t.horizontal ? S : g), 
            o(), r(), () => {
                n(), s();
            };
        }
    }), [ t, e, i ]), [ n, s ];
};

function x(t) {
    switch (t) {
      case c.RANGE:
        return this.to ** 2 + this.from;

      case c.SCROLL_SIZE:
        return this.scrollSize;

      default:
        return this.sizesHash;
    }
}

const v = (t, e) => {
    const [o, r] = n((() => [ o => t.on(o, e), () => e.map(x, t).join() ]), [ t, e ]);
    h(o, r, r);
}, z = t => (v(t.model, t.events), t.children()), O = o => {
    const {model: r, children: n, itemData: s, component: l = "div", header: a = null, footer: h = null, getKey: f = (t => t), tabIndex: u = -1, style: m, ...p} = o, [y, S] = w(r);
    return t(l, {
        ...p,
        style: {
            overflow: "auto",
            contain: "strict",
            ...m
        },
        ref: i((t => r.setScroller(t)), [ r ]),
        tabIndex: u,
        children: [ a, e("div", {
            ref: y,
            children: e("div", {
                ref: S,
                children: e(z, {
                    model: r,
                    events: [ c.RANGE ],
                    children: () => d(r, (t => e(n, {
                        model: r,
                        i: t,
                        data: s
                    }, f(t, s))))
                })
            })
        }), h ]
    });
}, b = "undefined" != typeof window ? r : s, E = (t, e) => b((() => (t.setScroller(e), 
() => t.setScroller(null))), [ t, e ]), I = (t, e, o) => s((() => {
    if (o) return o(), t.on(o, e);
}), [ t, o, e ]), j = t => l().current ||= new a(t), R = t => {
    const e = j(t);
    return b((() => e.set(t))), e;
};

export { O as List, z as Subscription, d as mapVisibleRange, f as mapVisibleRangeWithOffset, v as useComponentSubscription, E as useScroller, I as useSubscription, w as useSyncedStyles, R as useVirtual, j as useVirtualModel };
//# sourceMappingURL=index.js.map
